//------------------------------------------------------------------
#property copyright   "mladen"
#property link        "www.forex-tsd.com"
#property version     "1.00"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_plots   1
#property indicator_label1  "nromalized candles"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrGray,clrLimeGreen,clrOrange

//
//
//
//
//

input int period = 50; // Normalization period
double canc[],cano[],canh[],canl[],colors[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,cano  ,INDICATOR_DATA);
   SetIndexBuffer(1,canh  ,INDICATOR_DATA);
   SetIndexBuffer(2,canl  ,INDICATOR_DATA);
   SetIndexBuffer(3,canc  ,INDICATOR_DATA);
   SetIndexBuffer(4,colors,INDICATOR_COLOR_INDEX);
      IndicatorSetString(INDICATOR_SHORTNAME,"Normalized candles ("+(string)period+")");

   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{ 
   if (Bars(_Symbol,_Period)<rates_total) return(-1);
   
   for (int i=(int)MathMax(prev_calculated-1,0); i<rates_total && !IsStopped(); i++)
   {
      double values[4];
         double hh = high[i],ll=low[i];
            for (int k=1; k<period && (i-k)>=0; k++)
            {
               hh = MathMax(hh,high[i-k]);
               ll = MathMin(ll,low [i-k]);
            }
         double rng = hh-ll;            
         canh[i] = (high[i] -ll)/rng;
         canl[i] = (low[i]  -ll)/rng;
         cano[i] = (open[i] -ll)/rng;
         canc[i] = (close[i]-ll)/rng;
         colors[i] = close[i]>open[i] ? 1 : close[i]<open[i] ? 2 : 0; 
   }
   return(rates_total);
}